//+------------------------------------------------------------------+
//|                                               renko_ma_cross.mq4 |
//|                                                         renegate |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "renegate"
#property link      ""
//+==================================================================+
//|     2-  , |
//|                                                    |
//+==================================================================+

//+==================================================================+
//|                                                  |
//+==================================================================+
extern int       per_ema_fast = 5;      //   
extern int       per_ema_slow = 25;     //   
extern int       tp           = 1000;   //  
extern int       sl           = 1000;   //  
extern int       box          = 500;    //    
extern int		  MagicNumber  = 111;	 //   
extern double    Lot          = 1.0;    //   


//+==================================================================+
//|                                              |
//+==================================================================+
double Box;                      //       
double TP;                       //  -   
double SL;                       //  -   
//+==================================================================+
//|                                      |
//+==================================================================+
int init()
  {
   Box = box*Point;
   TP  = tp*Point;
   SL  = sl*Point;
   //Print(DoubleToStr(Box, 5), " ", DoubleToStr(TP, 5));
   return(0); //     
  } // int init()

//+==================================================================+
//|                                    |
//+==================================================================+
int deinit()
  {
   Comment("");
   return(0); //     
  } // int deinit()

//+==================================================================+
//|                                            |
//+==================================================================+
int start()
  {
   static bool pusk_exp = false;         //       
   static double ema_fast_curr = 0.0;    //  ,     ema 
   static double ema_slow_curr = 0.0;    //  ,     ema 
   static double ema_fast_prev = 0.0;    //  ,     ema   
   static double ema_slow_prev = 0.0;    //  ,     ema   
   static datetime time_for_shift_1;     //  ,        
   static int count = 0;                 //  ,    ,   
   static bool finish_count = false;     //       
   int n;                                // -
   double L;                             //  
   //-----------------------------------------------------------------
   //   .   
   //-----------------------------------------------------------------
   if (pusk_exp == false)
   {
    for (n = 100000; n >= 1; n--)
     {
      L = renko(iClose(NULL, 0, n)); //   ,  L != -1,  
      //--------------------------------------------------------------
      //     L != -1  ...
      //--------------------------------------------------------------
      if (L != -1)
      {
       ema_fast_curr = ema_fast_prev+(2.0/(per_ema_fast+1))*(L-ema_fast_prev);
       ema_slow_curr = ema_slow_prev+(2.0/(per_ema_slow+1))*(L-ema_slow_prev);
       //-------------------------------------------------------------
       //    ,    
       //-------------------------------------------------------------
       ema_fast_prev = ema_fast_curr;
       ema_slow_prev = ema_slow_curr;
       count++;
      } // if (L != -1)
     } // for (n = 1000; n >= 1; n--)
     time_for_shift_1 = iTime(NULL, 0, 1); //  ,        
     pusk_exp = true;    //  1-  
     return(0);          //     
   } // if (pusk_exp == false)
   //-----------------------------------------------------------------
   //   
   //-----------------------------------------------------------------
   if (finish_count == false)
   {
    Print("    = ", count);
    finish_count = true; //       
   } // if (finish_count == false)
   int prev_shift_was_1 = iBarShift(NULL, 0, time_for_shift_1, false); //     
   for (n = prev_shift_was_1; n>= 1; n--)
   {
    L = renko(iClose(NULL, 0, n)); //   ,  L != -1,  
    //--------------------------------------------------------------
    //     L != -1  ...
    //--------------------------------------------------------------
    if (L != -1)
    {
     ema_fast_curr = ema_fast_prev+(2.0/(per_ema_fast+1))*(L-ema_fast_prev);
     ema_slow_curr = ema_slow_prev+(2.0/(per_ema_slow+1))*(L-ema_slow_prev);
     //-------------------------------------------------------------
     //  1-      
     //-------------------------------------------------------------
     if (n == 1)
     {
      //------------------------------------------------------------
      //         
      //------------------------------------------------------------
      if ((ema_fast_curr > ema_slow_curr) && (ema_fast_prev < ema_slow_prev))
      {
       order_commander("BUY");
      } // if ((ema_fast_curr > ema_slow_curr) && (ema_fast_prev < ema_slow_prev))
      //------------------------------------------------------------
      //         
      //------------------------------------------------------------
      if ((ema_fast_curr < ema_slow_curr) && (ema_fast_prev > ema_slow_prev))
      {
       order_commander("SELL");
      } // if ((ema_fast_curr < ema_slow_curr) && (ema_fast_prev > ema_slow_prev))
      //------------------------------------------------------------
     } // if (n == 1)
     ema_fast_prev = ema_fast_curr;
     ema_slow_prev = ema_slow_curr;
    } // if (L != -1)   
   } // for (n = prev_shift_was_1; n>= 1; n--)
   time_for_shift_1 = iTime(NULL, 0, 1); //  ,          
   return(0); //     
  } // int start()

//+==================================================================+
//|                                                        |
//+==================================================================+

//+==================================================================+
//|  1:                      |
//+==================================================================+
double renko(double curr_price)
  {
   static double R;                 //       
   static bool pusk_1 = false;      //       
   //-----------------------------------------------------------------
   //        
   //-----------------------------------------------------------------
   if (pusk_1 == false)
   {
    R = (MathFloor((curr_price-0.0)/Box))*Box+0.0;
    pusk_1 = true;    //  1-     
    return(R); //   
   } // if (pusk_1 == false)
   //-----------------------------------------------------------------
   //    
   //-----------------------------------------------------------------
   if (curr_price >= R+Box) //  
   {
    R = R+Box;
    return(R); //   
   } // if (curr_price >= R+Box)  //  
   //-----------------------------------------------------------------
   if (curr_price <= R-Box) //  
   {
    R = R-Box;
    return(R); //   
   } // if (curr_price <= R-Box) //  
   //-----------------------------------------------------------------
   return(-1); //     ,    -1
  } // double renko(double curr_price)

//+==================================================================+
//|  2:                                   |
//+==================================================================+
int order_commander(string napravlenie)
  {
   //-----------------------------------------------------------------
   //  
   //-----------------------------------------------------------------
   int _OrdersTotal = OrdersTotal(); //   
	bool ExpertOrder = false; // -
	//-----------------------------------------------------------------
	//     
	//-----------------------------------------------------------------
	for (int z = _OrdersTotal - 1; z >= 0; z --)
	{
	 //---------------------------------------------------------------
	 //     OrderSelect
	 //---------------------------------------------------------------
	 if (!OrderSelect(z, SELECT_BY_POS, MODE_TRADES))
	 {
	  continue;
	 } // if (!OrderSelect(z, SELECT_BY_POS, MODE_TRADES))
	 //---------------------------------------------------------------
	 //    OrderMagicNumber,  .  OrderSymbol
	 //---------------------------------------------------------------
	 if (OrderMagicNumber() != MagicNumber || OrderSymbol() != Symbol())
	 {
	  continue;
	 } // if (OrderMagicNumber() != MagicNumber || OrderSymbol() != Symbol())
	 ExpertOrder = true; //    
	 //---------------------------------------------------------------
	 //   
	 //---------------------------------------------------------------
	 if (OrderType() == OP_BUY)
	 {
	  if (napravlenie == "SELL")
	  {
	   //-----------------------------------------------------------
	   //  
	   //-----------------------------------------------------------
      if (!OrderClose(OrderTicket(), OrderLots(), Bid, 0, Blue))
      {
       Alert ("   BUY-!!!");
      } // if (!OrderClose(OrderTicket(), OrderLots(), Bid, 0, Blue))
     } // if (napravlenie == 'SELL')
	  continue; //    
	 } // if (OrderType() == OP_BUY)
	 //---------------------------------------------------------------
	 //   
	 //---------------------------------------------------------------
    if (OrderType() == OP_SELL)
    {
     if (napravlenie == "BUY")
     {
      //-----------------------------------------------------------
      //  
      //-----------------------------------------------------------
      if (!OrderClose(OrderTicket(), OrderLots(), Ask, 0, Red))
      {
       Alert ("   SELL-!!!");
      } // if (!OrderClose(OrderTicket(), OrderLots(), Ask, 0, Red))
	  } // if (napravlenie == 'BUY')
    } // if (OrderType() == OP_SELL)
   } // for (int z = _OrdersTotal - 1; z >= 0; z --)
   //--------------------------------------------------------------
   //  
   //--------------------------------------------------------------
   double StopLoss, TakeProfit;
   if (napravlenie == "SELL") //    
   {
    //-------------------------------------------------------------
    //   -
    //-------------------------------------------------------------
    if (SL > 0 )
    {
     StopLoss = NormalizeDouble(Ask + SL, Digits);
    }
    else
    {
     StopLoss = 0.0;
    } // if (SL > 0 )
    //-------------------------------------------------------------
    //   -
    //-------------------------------------------------------------
    if (TP > 0 )
    {
     TakeProfit = NormalizeDouble(Ask - TP, Digits);
    }
    else
    {
     TakeProfit = 0.0;
    } // if (TP > 0 )
    //-------------------------------------------------------------
    //    
    //-------------------------------------------------------------
    if(OrderSend(Symbol(), OP_SELL, Lot, Bid, 0, StopLoss, TakeProfit, "renko_ma_cross", MagicNumber) < 0)
    {
     Alert("   SELL-!!!");
    } // if(OrderSend(Symbol(), OP_SELL, Lot, Bid, 0, StopLoss, TakeProfit, "renko_ma_cross", MagicNumber) < 0)
   } // if (napravlenie == "SELL")  //    
   
   if (napravlenie == "BUY") //    
   {
    //-------------------------------------------------------------
    //   -
    //-------------------------------------------------------------
    if (SL > 0 )
    {
     StopLoss = NormalizeDouble(Bid - SL, Digits);
    }
    else
    {
     StopLoss = 0.0;
    } // if (SL > 0 )
    //-------------------------------------------------------------
    //   -
    //-------------------------------------------------------------
    if (TP > 0 )
    {
     TakeProfit = NormalizeDouble(Bid + TP, Digits);
    }
    else
    {
     TakeProfit = 0.0;
    } // if (TP > 0 )
    //-------------------------------------------------------------
    //    
    //-------------------------------------------------------------
    if(OrderSend(Symbol(), OP_BUY, Lot, Ask, 0, StopLoss, TakeProfit, "renko_ma_cross", MagicNumber) < 0)
    {
     Alert("   BUY-!!!");
    } // if(OrderSend(Symbol(), OP_BUY, Lot, Ask, 0, StopLoss, TakeProfit, "renko_ma_cross", MagicNumber) < 0)
   } // if (napravlenie == "BUY") //       
   return(0);  //   
  } // int order_commander(string napravlenie)